const _Http = getApp().globalData.http;
Page({
    data: {
        isLeader: false, //是否为负责人
        tabsActive: 0, //tabs 选中项
        sat_orderclueid: "",
        detail: '',
        tabsList: [{
            label: "详细信息",
            icon: "icon-tabxiangxixinxi1"
        }, {
            label: "跟进记录",
            icon: "icon-tabgenjinjilu"
        }, {
            label: "操作",
            icon: "icon-tabcaozuojilu1"
        }, {
            label: "跟进动态",
            icon: "icon-tabgenjinjilu"
        }, {
            label: "任务",
            icon: "icon-tabrenwu"
        }, {
            label: "附件",
            icon: "icon-tabfujian1"
        }],
        tabbarList: [{
            icon: "icon-bianji",
            label: "编辑"
        }, {
            icon: "icon-zhuanyi",
            label: "分配"
        }, {
            icon: "icon-dibu-jieshu",
            label: "删除"
        }],
    },
    onLoad(options) {
        this.setData({
            sat_orderclueid: options.sat_orderclueid,
            isAdmin: wx.getStorageSync('auth').wCustomer.options.some(v => v == "admin"), //是否具有管理权限
        });
        this.getDetail();
    },
    getDetail() {
        _Http.basic({
            "classname": "webmanage.saletool.orderclue.publicclue.PublicClue",
            "method": "selectDetail",
            "version": 1,
            "content": {
                "nocache": true,
                "sat_orderclueid": this.data.sat_orderclueid
            },
        }).then(res => {
            console.log("线索详情", res)
            if (res.msg != '成功') return wx.showToast({
                title: res.msg,
                icon: "none"
            });

            this.setData({
                isLeader: res.data.createuserid == wx.getStorageSync('userMsg').userid,
                detail: res.data,
                briefs: [{
                        label: "联系人",
                        value: res.data.name
                    }, {
                        label: "手机号",
                        value: res.data.phonenumber
                    }, {
                        label: "市场活动",
                        value: res.data.campaign_name
                    }, {
                        label: '负责人',
                        value: res.data.leader && res.data.leader.length > 0 ? res.data.leader[0].name : ''
                    },
                    {
                        label: '分配状态',
                        value: res.data.allocationstatus
                    },
                    {
                        label: '跟进状态',
                        value: res.data.status
                    },
                    {
                        label: '跟进次数',
                        value: res.data.followcount || '0'
                    },
                ],
                list1: [{
                    label: "客户(企业)",
                    value: res.data.enterprisename_customer
                }, {
                    label: "联系人",
                    value: res.data.name
                }, {
                    label: "手机号码",
                    value: res.data.phonenumber
                }, {
                    label: "省市县",
                    value: res.data.province ? res.data.province + res.data.city + res.data.county : ''
                }, {
                    label: "地址",
                    value: res.data.address
                }, {
                    label: "项目名称",
                    value: res.data.projectname
                }, {
                    label: "项目规模",
                    value: res.data.scale
                }, {
                    label: "总投资额(万元)",
                    value: res.data.totalinvestment
                }, {
                    label: "造价(万元)",
                    value: res.data.costofconstruction
                }, {
                    label: "预计开工时间",
                    value: res.data.begdate_due
                }, {
                    label: "预计完工时间",
                    value: res.data.enddate_due
                }, {
                    label: "市场活动",
                    value: res.data.campaign_name
                }, {
                    label: "来源",
                    value: res.data.cluesource
                }, {
                    label: "线索概括",
                    value: res.data.notes
                }, {
                    label: '所属业务员',
                    value: res.data.salename
                }, {
                    label: '负责人',
                    value: res.data.leader && res.data.leader.length > 0 ? res.data.leader[0].name : ''
                }, {
                    label: '分配状态',
                    value: res.data.allocationstatus
                }, {
                    label: '跟进状态',
                    value: res.data.status
                }],
                list2: [{
                    label: "创建人",
                    value: res.data.createBy
                }, {
                    label: "创建时间",
                    value: res.data.createDate
                }, {
                    label: "分配人",
                    value: res.data.assignedBy
                }, {
                    label: "分配时间",
                    value: res.data.assignedDate
                }, {
                    label: "分配人",
                    value: res.data.assignedBy
                }, {
                    label: "分配时间",
                    value: res.data.assignedDate
                }, {
                    label: "最近跟进人",
                    value: res.data.followBy
                }, {
                    label: "最近跟进时间",
                    value: res.data.followDate
                }, {
                    label: "最近编辑人",
                    value: res.data.editBy
                }, {
                    label: "最近编辑时间",
                    value: res.data.editDate
                }, {
                    label: "无效原因",
                    value: res.data.invalidreason
                }, {
                    label: "作废原因",
                    value: res.data.deletereason
                }, {
                    label: "跟进次数",
                    value: res.data.followcount
                }],
                tabsList: this.data.tabsList,
            });
            /* {
                label: "转移人",
                value: res.data.changeBy
            }, {
                label: "最近转移时间",
                value: res.data.changeDate
            } */
            var arr = this.data.tabbarList
            if (res.data.status != '待跟进') {
                arr = arr.filter(item => {
                    return item.label != '编辑' && item.label != '撤回'
                })
            }
            /* 更新列表中状态 */
            let page = getCurrentPages().find(v => v.__route__ == 'packageA/publicClue/index');
            if (page) {
                let index = page.data.list.findIndex(v => v.sat_orderclueid == res.data.sat_orderclueid);
                if (index != -1) page.setData({
                    [`list[${index}].status`]: res.data.status
                })
            }
            this.setData({
                tabbarList: arr
            })
            this.getTags();
            this.partialRenewal();
        })
    },
    //tabs 切换
    tabsChange({
        detail
    }) {
        this.setData({
            tabsActive: detail
        });
        this.partialRenewal();
    },
    //更新标签
    getTags() {
        this.selectComponent("#Tags").getTags();
    },
    //局部数据更新 tabs
    partialRenewal(init = false) {
        let id = this.data.detail.sat_orderclueid;
        let model = '';
        let name = this.data.tabsList[this.data.tabsActive].label;
        switch (name) {
            case "任务":
                model = "#Work"
                break;
            case "跟进记录":
                model = "#follow"
                break;
            case "操作":
                model = "#Record"
                break;
            case "跟进动态":
                model = "#Trace"
                break;
            case "附件":
                model = "#Files"
                break;
        };
        if (model) {
            // 确定好模块ID total = null 是第一次加载 加载数据
            // init是新增或修改需要清数据
            let Component = this.selectComponent(model);
            const {
                total,
                pageNumber,
                pageTotal
            } = Component.data.content;
            if (total == null || init) {
                Component.getList(id, init);
            } else if (pageNumber <= pageTotal) {
                Component.getList(id, false);
            } else {
                //用来判断 在搜索页面修改，与tabs选项不一致 但是切换到该选项 重置数据
            }
        }
    },
    onReachBottom() {
        this.partialRenewal();
    },
    //详情按钮回调
    tabbarOnClick({
        detail
    }) {
        let data = this.data.detail,
            that = this;
        switch (detail.label) {
            case "编辑":
                wx.navigateTo({
                    url: `/packageA/publicClue/addClue?rowData=${JSON.stringify(this.data.detail)}`,
                })
                break;
            case "分配":
                wx.navigateTo({
                    url: `/packageA/publicClue/distribution?data=${JSON.stringify(this.data.detail)}`,
                })
                break;
            case "删除":
                wx.showModal({
                    title: '提示',
                    content: `是否确认删除该线索？`,
                    complete: ({
                        confirm
                    }) => {
                        if (confirm) _Http.basic({
                            "id": 20221101100502,
                            "content": {
                                "sat_orderclueids": [this.data.detail.sat_orderclueid]
                            }
                        }).then(res => {
                            wx.showToast({
                                title: res.msg == '成功' ? `操作成功` : res.msg,
                                icon: "none"
                            });
                            setTimeout(() => {
                                wx.navigateBack()
                                getCurrentPages().forEach(v => {
                                    if (v.__route__ == "packageA/publicClue/index") {
                                        v.getList(true)
                                    }
                                })
                            }, 300)

                        })
                    }
                })
                break;
            case "撤回":
                wx.showModal({
                    title: '提示',
                    content: `是否确认撤回该线索？`,
                    complete: ({
                        confirm
                    }) => {
                        if (confirm) _Http.basic({
                            classname: "webmanage.saletool.orderclue.publicclue.PublicClue",
                            method: "revoke",
                            "content": {
                                "sat_orderclueid": this.data.detail.sat_orderclueid
                            }
                        }).then(res => {
                            setTimeout(() => {
                                wx.showToast({
                                    title: res.msg == '成功' ? `操作成功` : res.msg,
                                    icon: "none"
                                });
                            }, 1000)
                            if (res.msg == '成功') this.getDetail()
                        })
                    }
                })
                break;
            case "更换负责人":
                wx.navigateTo({
                    url: `/pages/group/select?data=${JSON.stringify({
                             ownertable:"sat_orderclue",
                             ownerid:data.sat_orderclueid,
                        })}&radio=true&principal=true`,
                })
                break;
        }
    },
    /* 更换负责人 */
    handelSubmit(arr) {
        const that = this;
        wx.showModal({
            title: '提示',
            content: '是否确认更换负责人',
            complete: ({
                confirm
            }) => {
                if (confirm) _Http.basic({
                    "id": 20220930103701,
                    "content": {
                        ownertable: "sat_orderclue",
                        ownerid: that.data.detail.sat_orderclueid,
                        userid: arr[0]
                    }
                }).then(res => {
                    console.log("更换负责人", res)
                    if (res.msg != '成功') return wx.showToast({
                        title: res.data,
                        icon: "none"
                    });
                    wx.showToast({
                        title: '更换成功！',
                        icon: "none"
                    });
                    setTimeout(() => {
                        that.getDetail();
                        wx.navigateBack();
                        /*  getCurrentPages().forEach(v => {
                             if (['packageA/project/index'].includes(v.__route__)) v.getList(true)
                         }) */
                    }, 300)
                })
            }
        })
    },
    onShareAppMessage() {}
})